require 'csv'
require 'securerandom'

#SUPER_HACKER
module SuperHacker

  VERSION = "1.0.6"

  class Hacker
    def initialize
      #codegeneratorを作成
      @cg = CodeGenerator.new()
    end

    #IPアドレスを入力するまでのシーン
    def scene_input_ip
          ip = "192.168.#{rand(1..99)}.#{rand(1..99)}"
          @cg.type_word_code("You are get ip address #{ip}")
          @cg.type_word_code("Plz input ip address")
          print "[IP]> "
          user_input_ip = gets.chomp()
          #比較結果を返す
          user_input_ip == ip
    end

    #loginするまでのシーン
    def scene_login
      #ダウンロード成功、色々流れてくる。
      @cg.type_word_code("[CONNECTION SUCCESS]",0.02,0.01)
      @cg.type_word_code("Downloading..",0.02,0.01)
      @cg.print_progres()
      @cg.read_csv(__dir__ + "/../csv/download.csv",0.00001,0.00001)

      #パスワードを入力させる
      create_password = SecureRandom.base64(4)
      @cg.type_word_code("You are get password: #{create_password}")
      @cg.type_word_code("Plz input password")
      print "[Password]> "
      password = gets.chomp()

      #比較結果を返す
      create_password == password
    end

    #成功
    def scene_success
      @cg.read_csv(__dir__ + "/../csv/success.csv",0.001,0.001)
    end

    #失敗
    def scene_faild
      @cg.read_csv(__dir__ + "/../csv/faild.csv",0.001,0.001)
    end

    #実装部分
    def step
      #初期化csvファイルの読み込み
      @cg.read_csv(__dir__ + "/../csv/init.csv",0.001,0.001)

      loop do
        #メニュー表示
        @cg.read_csv(__dir__ + "/../csv/menu.csv")

        print("(HACK_MENU)> ")
        input = gets.chomp

        if input == "hax"
          #haxコードの表示
          @cg.read_csv(__dir__ + '/../csv/hax.csv',0.002,0.0001)
          @cg.read_csv(__dir__ + '/../csv/log.csv',0.002,0.0001)

          #IPアドレスを入力させる
          if scene_input_ip == false
            @cg.type_word_code("You are input mistakes..")
            scene_faild
            next
          end

          #loginするまでのシーン
          if scene_login == false
            @cg.type_word_code("You are input mistakes..")
            scene_faild
            next
          end

          #クリア
          @cg.type_word_code("Infiltration succeeded")

          #成功
          scene_success

        elsif input == "exit" || input == "quit"
          #終了
          @cg.type_word_code("bye..")
          break
        else
          #入力ミス
          @cg.type_word_code("!!INPUT ERROR!!")
        end
      end
    end

  end
  #CreateCode
  class CodeGenerator
      def initialize
      end
      #単語毎に区切って表示
      def type_word_code(str,split_sleep = 0.02,typing_sleep = 0.02)
          str.chars do |s|
              #もし空白なら空白用のスリープ時間を適用
              if s == ' ' || s == '\t'
                  sleep(split_sleep)
                  print s
              else
                  sleep(typing_sleep)
                  print s
              end
          end
          puts
      end

      #プログレスバーの表示
      def print_progres()
          100.times do |num|
          print "#{num}%\r"
          sleep 0.025
          STDOUT.flush
          end
      end

      #CSVファイルの読み込み
      def read_csv(file_name,sleep_time = 0.001,word_sleep = 0.02)
          csv_data = CSV.read(file_name, headers: true)
          csv_data.each do |data|
              #もしテキストがなければ改行して次の文字へ
              if data["text"].nil?
                  puts
                  next
              end

              #sleep_timeが設定されていれば、csvファイルのほうを有効にする
              if data["sleep_time"].nil? == false
                  type_word_code(data["text"],word_sleep,data["sleep_time"].to_f)
              else
                  #csvデータを表示する
                  type_word_code(data["text"],word_sleep,sleep_time)
              end
          end
      end

  end
end